<?

// BOLK. v0.2

class WikiStyle
{
	var $curlevel, $endtags;

	function parse ($text)
	{
		$wc = 'a-zA-Z0-9--';
		// avoid changing things inside {{{ }}} environments

		$storage = array ();
		$text = preg_replace
		(
			'/\{\{\{(.*?)\}\}\}/se',
			"'{{{'.(array_push (\$storage, strtr ('\$1', array ('\\\"' => '\"'))) - 1).'}}}'",
			$text
		);

		// hr  br

		$text = str_replace ('----', '<hr />', $text);
		$text = str_replace ('---',  '<br />', $text);

		//  
		$text = preg_replace_callback
		(
			'/(^\s*\|\|.*\|\|(?:\r?\n|$))+/m',
			array (&$this, '_table'),
			$text
		);

		//  

		$text = preg_replace_callback
		(
			'/^ {2,}(\*|.\.).*(?:\r?\n|$)(^ {2,}.*(?:\r?\n|$))*/m',
			array (&$this, '_slist'),
			$text
		);

		// B, S, U, TT, A, CENTER

		$text = preg_replace_callback
		(
			"!(\\*\\*|__|\\-\\-|##)(\S.*?\S|\S)(\\1)!s",
			array (&$this, '_bisu'),
			$text
		);

		// I (and escaping from links)

		$text = preg_replace_callback
		(
			"{(?<!:)//(\S.*?\S|\S)(?<!:)//}s",
			array (&$this, '_bisu'),
			$text
		);

		// A
		$text = preg_replace_callback
		(
			"!(\[\[\|\(\()(\S.*?\S|\S)(\]\]|\)\))!s",
			array (&$this, '_bisu'),
			$text
		);

		// CENTER
		$text = preg_replace_callback
		(
			"!(>>)(\S.*?\S|\S)(<<)!s",
			array (&$this, '_bisu'),
			$text
		);

		// Hx
		$text = preg_replace_callback
		(
			'!(={2,7})\s(.*?)\s(\\1)!',
			array (&$this, '_hx'),
			$text
		);

		// SUP, SUB
		$pats = array
		(
			"/([$wc])\^\^([$wc](?:[$wc\s]*[$wc])?)\^\^/",
			"/([$wc])vv([$wc](?:[$wc\s]*[$wc])?)vv/",
		);

		$reps = array
		(
			'$1<sup>$2</sup>',
			'$1<sub>$2</sub>',
		);

		$text = preg_replace ($pats, $reps, $text);
		// $text = nl2br($text);

		// {{{  }}}   <PRE> (<TT>)  </PRE> (</TT>)   
		$text = preg_replace
		(
			'/\{\{\{(\d+)\}\}\}/e',
			"strpos(\$storage[\$1], \"\\n\") === false ? '<tt>'.\$storage[\$1].'</tt>' : '<pre>'.\$storage[\$1].'</pre>'",
			$text
		);

		return $text;
	}

	// Bold, Italic, Strikethrough, Underscore, TT, anchor

	function _bisu ($regs)
	{
		$pair = array ('>>' => '<<', '[[' => ']]', '((' => '))');

		if ($regs[1] <> strrev ($regs[3]) && $pair[$regs[1]] <> $regs[3]) return $regs[0];

		if ($regs[1] == '[[' || $regs[1] == '((')
		{
			if (preg_match('!^(?:(?:http|gopher|ftp|https)://|mailto:)(.+)$!', $regs[2], $r))
			{
				$address = $regs[2];
				$str     = $r[1];
			} else
			{
				$address = "http://$regs[2]";
				$str     = $regs[2];
			};

			return '<a href="'.htmlspecialchars($address).'">'.$str.'</a>';
		};

		$trans = array
			(
				'--' => '<s style="color:gray">',
				'//' => '<i>',
				'**' => '<b>',
				'__' => '<u>',
				'##' => '<tt>',
				'>>' => '<center>',
			);

		$regs[1] = strtr ($regs[1], $trans);

		$trans = array
			(
				'--' => '</s>',
				'//' => '</i>',
				'**' => '</b>',
				'__' => '</u>',
				'##' => '</tt>',
				'<<' => '</center>',
			);
		$regs[3] = strtr ($regs[3], $trans);

		return $regs[1].nl2br($regs[2]).$regs[3];
	}

	// Table

	function _table($regs)
	{
		$text = '<table border=1>' . 
				preg_replace ('/^\s*\|\|(.*?)\|\|(?:$|\r?\n)/m', "<tr><td>\$1</td></tr>", $regs[0]) .
				'</table>';

		return str_replace('||', '</td><td>', $text);
	}

	// UL, LI

	function _slist_element($p)
	{
		$level = strspn($p[1], ' ');
		$c     = $p[1][$level];

		if ($level & 1 || ($c != '*' && $p[1][$level+1] != '.')) return $p[0];

		$level /= 2;
		$pref   = '';

		if ($this->curlevel == $level) return '<li>';

		if ($c == '*')
		{
			$tag    = '<ul>';
			$endtag = '</ul>';
		} else
		{
			$tag    = "<ol type=\"$c\"" . ($p[2]?" start=\"$p[3]\"" : "")  .">";
			$endtag = '</ol>';
		};

		$diff = abs ($level-$this->curlevel);

		if ($this->curlevel < $level)
		{
			$pref         .= str_repeat($tag, $diff);
			$this->endtags = str_repeat($endtag, $diff).$this->endtags;
		}
		else
		{
			$pref          = substr($this->endtags, 0, 5*$diff);
			$this->endtags = substr($this->endtags, 5*$diff);
		}

		$this->curlevel = $level;
		return $pref.'<li>';
	}

	function _slist($p)
	{
		$this->curlevel = 0;
		$this->endtags  = '';

		return preg_replace_callback
		(
			'/^( {2,}.{2})(#(\d+))?\s*/m',
			array (&$this, '_slist_element'),
		$p[0]
		) .
			$this->endtags;
	}

	// Hx

	function _hx($regs)
	{
		$tag = 'h'.(strlen($regs[1])-1);
		return "<$tag>$regs[2]</$tag>";
	}
};

?>
