<?
	function imagesx($im)
	{
		return $im['w'];
	};

	function imagesy($im)
	{
		return $im['h'];
	};

	function imagecreate($width, $height)
	{
		$col   = array_pad (array(), $height, 0);
		$image = array_pad (array(), ceil($width/8), $col);

		return array
		(
			'w'	=> $width,
			'h' => $height,
			'i' => $image
		);
	};

	function imagecolorallocate (&$im, $r, $g, $b)
	{
		return (int) ($r > 127 || $b > 127 || $b > 127);
	};

	function imagerectangle(&$im, $x1, $y1, $x2, $y2, $color)
	{
		if (!is_array($im)) return;

		imageline ($im, $x1, $y1, $x2, $y1, $color);
		imageline ($im, $x2, $y1, $x2, $y2, $color);
		imageline ($im, $x2, $y2, $x1, $y2, $color);
		imageline ($im, $x1, $y2, $x1, $y1, $color);
	};

	function imageline (&$im, $x1, $y1, $x2, $y2, $color)
	{
		if (!is_array($im)) return;

		$step = 0;
		$dx   = abs($x2 - $x1);
		$sx   = ($x2 - $x1) > 0 ? 1 : -1;
		$dy   = abs($y2 - $y1);
		$sy   = ($y2 - $y1) > 0 ? 1 : -1;

		if ($dy > $dx)
		{
			$step = 1;
			list ($x1, $y1) = array ($y1, $x1);
			list ($dx, $dy) = array ($dy, $dx);
			list ($sx, $sy) = array ($sy, $sx);
		};


		$e = 2 * $dy - $dx;

		for ($i = 0; $i < $dx; $i++)
		{
			$step ? imagesetpixel ($im, $y1, $x1, $color) :
				    imagesetpixel ($im, $x1, $y1, $color);

			while ($e >= 0)
			{
				$y1 += $sy;
				$e  -= 2 * $dx;
			};

			$x1 += $sx;
            $e  += 2 * $dy;
		};

		imagesetpixel ($im, $x2, $y2, $color);
	};

	function imagesetpixel (&$im, $x, $y, $color)
	{
		if (!is_array($im)) return;

		if ($x >= 0 && $y >=0 && $x < $im['w'] && $y < $im['h'])
		if ($color)
		$im['i'][$x >> 3][$y] |= 1 << ($x % 8); else
		$im['i'][$x >> 3][$y] &= 255 ^ (1 << ($x % 8));
	};

	function imagegetpixel ($im, $x, $y)
	{
		if (!is_array($im)) return;

		if ($x >= 0 && $y >=0 && $x < $im['w'] && $y < $im['h'])
		return $im['i'][$x >> 3][$y] & (1 << ($x % 8)) ? 1  : 0;

		return 0;
	};

	function imagexbm ($im, $filename)
	{
		if (!is_array($im)) return;

		$s = "<?ob_start('ob_gzhandler');?>".
			 "#define _width {$im['w']}\n".
			 "#define _height {$im['h']}\n".
			 "static unsigned char _bits[] = {\n";

		for ($i = 0; $i<$im['h']; $i++)
		for ($j = 0; $j<count($im['i']); $j++)
		$s .= '0x'.dechex ($im['i'][$j][$i]).', ';

		$s = rtrim ($s, ', ')."\n}<?ob_end_flush();?>";

		$fp = @fopen ($filename, 'w');
		if ($fp)
		{
			fwrite ($fp, $s);
			fclose ($fp);
		};
	};

	function imagedestroy(&$im)
	{
		$im = FALSE;
	};

	function imagefilledrectangle(&$im, $x1, $y1, $x2, $y2, $color)
	{
		for ($i = min($x1, $x2); $i<max($x1, $x2); $i++)
		for ($j = min($y1, $y2); $j<max($y1, $y2); $j++)
		imagesetpixel ($im, $i, $j, $color);
	};

	function imagecopy (&$im, $im2, $dx, $dy, $sx, $sy, $sw, $sh, $xor = FALSE)
	{
		if (!is_array($im) || !is_array($im2)) return;

		for ($i = 0; $i<$sw; $i++)
		for ($j = 0; $j<$sh; $j++)
		if ($xor === FALSE)
		imagesetpixel ($im, $dx+$i, $dy+$j, imagegetpixel ($im2, $sx+$i, $sy+$j)); else
		{
			$val = imagegetpixel ($im,  $dx+$i, $dy+$j) ^
				   imagegetpixel ($im2, $sx+$i, $sy+$j);

			imagesetpixel ($im, $dx+$i, $dy+$j, $val);
		};
	};

	function imagestring(&$im, $font, $x, $y, $str, $color)
	{
		global $PGD_FONT;

		if (!is_array($PGD_FONT[$font]) || !is_array($im)) return;
		$str = (string) $str;

		for ($i = 0; $i<strlen($str); $i++)
		{
			if (ord($str[$i]) >= $PGD_FONT[$font]['cs'] && ord($str[$i]) <= $PGD_FONT[$font]['ce'])
			imagecopy
			(
				$im,
				$PGD_FONT[$font],
				$x + $PGD_FONT[$font]['cw']*$i,
				$y,
				(ord($str[$i]) - $PGD_FONT[$font]['cs']) * $PGD_FONT[$font]['cw'],
				0, $PGD_FONT[$font]['cw'],
				$PGD_FONT[$font]['ch'],
				TRUE
			);
		};
	};

	function imagechar (&$im, $font, $x, $y, $str, $color)
	{
		return imagestring($im, $font, $x, $y, $str, $color);
	};

	function imageloadfont($filename)
	{
		global $PGD_FONT;
		if (!is_array($PGD_FONT)) $PGD_FONT = array();
		$num = count($PGD_FONT)+1;

		$fp = @fopen ($filename, 'r');
		if ($fp)
		{
			$img = split (" *, *", fread ($fp, filesize($filename)));
			fclose ($fp);
			// h, w, char width, char height, char start, char end

			$f = array ('h', 'w', 'cw', 'ch', 'cs', 'ce');
			for ($l = 0; $l<count($f); $l++)
			$PGD_FONT[$num][$f[$l]] = $img[$l];

			// font itself

			for ($j = 0; $j<$PGD_FONT[$num]['h']; $j++)
			for ($i = 0; $i<ceil($PGD_FONT[$num]['w']/8); $i++)
			$PGD_FONT[$num]['i'][$i][$j] = hexdec(substr ($img[$l++], 2));
		};
		return $num;
	};
?>
